"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_fast_compare_1 = __importDefault(require("react-fast-compare"));
var styles_1 = __importDefault(require("./styles"));
var types_1 = require("./types");
var draw_1 = __importDefault(require("./draw"));
var events_1 = require("./events");
var ImageMapper = function (props) {
    var containerRef = props.containerRef, active = props.active, disabled = props.disabled, fillColorProp = props.fillColor, lineWidthProp = props.lineWidth, mapProp = props.map, srcProp = props.src, strokeColorProp = props.strokeColor, natural = props.natural, heightProp = props.height, widthProp = props.width, imageWidthProp = props.imgWidth, areaKeyName = props.areaKeyName, stayHighlighted = props.stayHighlighted, stayMultiHighlighted = props.stayMultiHighlighted, toggleHighlighted = props.toggleHighlighted, parentWidth = props.parentWidth, responsive = props.responsive;
    var _a = react_1.useState(mapProp), map = _a[0], setMap = _a[1];
    var _b = react_1.useState(map), storedMap = _b[0], setStoredMap = _b[1];
    var _c = react_1.useState(false), isRendered = _c[0], setRendered = _c[1];
    var _d = react_1.useState(null), imgRef = _d[0], setImgRef = _d[1];
    var container = react_1.useRef(null);
    var img = react_1.useRef(null);
    var canvas = react_1.useRef(null);
    var ctx = react_1.useRef(null);
    var isInitialMount = react_1.useRef(true);
    react_1.useEffect(function () {
        if (isInitialMount.current) {
            isInitialMount.current = false;
        }
        else {
            updateCacheMap();
            initCanvas();
            updateCanvas();
        }
    }, [props, isInitialMount]);
    react_1.useEffect(function () {
        ctx.current = canvas.current.getContext('2d');
        updateCacheMap();
        setRendered(true);
    }, []);
    react_1.useEffect(function () {
        container.current.clearHighlightedArea = function () {
            setMap(storedMap);
            initCanvas();
        };
        if (containerRef) {
            containerRef.current = container.current;
        }
    }, []);
    react_1.useEffect(function () {
        if (responsive)
            initCanvas();
    }, [parentWidth]);
    var updateCacheMap = function () {
        setMap(mapProp);
        setStoredMap(mapProp);
    };
    var getDimensions = function (type) {
        if (typeof props[type] === 'function') {
            // @ts-ignore
            return props[type](img.current);
        }
        return props[type];
    };
    var getValues = function (type, measure, name) {
        if (name === void 0) { name = 'area'; }
        var _a = img.current, naturalWidth = _a.naturalWidth, naturalHeight = _a.naturalHeight, clientWidth = _a.clientWidth, clientHeight = _a.clientHeight;
        if (type === 'width') {
            if (responsive)
                return parentWidth;
            if (natural)
                return naturalWidth;
            if (widthProp || name === 'image')
                return measure;
            return clientWidth;
        }
        if (type === 'height') {
            if (responsive)
                return clientHeight;
            if (natural)
                return naturalHeight;
            if (heightProp || name === 'image')
                return measure;
            return clientHeight;
        }
        return 0;
    };
    var initCanvas = function (firstLoad) {
        if (firstLoad === void 0) { firstLoad = false; }
        var imgWidth = getDimensions('width');
        var imgHeight = getDimensions('height');
        var imageWidth = getValues('width', imgWidth);
        var imageHeight = getValues('height', imgHeight);
        if (widthProp || responsive) {
            img.current.width = getValues('width', imgWidth, 'image');
        }
        if (heightProp || responsive) {
            img.current.height = getValues('height', imgHeight, 'image');
        }
        canvas.current.width = imageWidth;
        canvas.current.height = imageHeight;
        container.current.style.width = imageWidth + "px";
        container.current.style.height = imageHeight + "px";
        ctx.current = canvas.current.getContext('2d');
        ctx.current.fillStyle = fillColorProp;
        //ctx.strokeStyle = props.strokeColor;
        if (props.onLoad && firstLoad) {
            props.onLoad(img.current, {
                width: imageWidth,
                height: imageHeight,
            });
        }
        setImgRef(img.current);
        renderPrefilledAreas();
    };
    var hoverOn = function (area, index, event) {
        var shape = area.shape, scaledCoords = area.scaledCoords, fillColor = area.fillColor, lineWidth = area.lineWidth, strokeColor = area.strokeColor, isAreaActive = area.active;
        if (active) {
            draw_1.default(shape, scaledCoords, fillColor || fillColorProp, lineWidth || lineWidthProp, strokeColor || strokeColorProp, isAreaActive !== null && isAreaActive !== void 0 ? isAreaActive : true, ctx);
        }
        if (props.onMouseEnter)
            props.onMouseEnter(area, index, event);
    };
    var hoverOff = function (area, index, event) {
        if (active) {
            ctx.current.clearRect(0, 0, canvas.current.width, canvas.current.height);
            renderPrefilledAreas();
        }
        if (props.onMouseLeave)
            props.onMouseLeave(area, index, event);
    };
    var click = function (area, index, event) {
        var _a;
        var isAreaActive = (_a = area.active) !== null && _a !== void 0 ? _a : true;
        if (isAreaActive && (stayHighlighted || stayMultiHighlighted || toggleHighlighted)) {
            var newArea_1 = __assign({}, area);
            var chosenArea = stayMultiHighlighted ? map : storedMap;
            if (toggleHighlighted && newArea_1.preFillColor) {
                delete newArea_1.preFillColor;
            }
            else if (stayHighlighted || stayMultiHighlighted) {
                newArea_1.preFillColor = area.fillColor || fillColorProp;
            }
            var updatedAreas_1 = chosenArea.areas.map(function (cur) {
                return cur[areaKeyName] === area[areaKeyName] ? newArea_1 : cur;
            });
            setMap(function (prev) { return (__assign(__assign({}, prev), { areas: updatedAreas_1 })); });
        }
        if (props.onClick) {
            event.preventDefault();
            props.onClick(area, index, event);
        }
    };
    var scaleCoords = function (coords) {
        var scale = widthProp && imageWidthProp && imageWidthProp > 0
            ? widthProp / imageWidthProp
            : 1;
        if (responsive && parentWidth) {
            return coords.map(function (coord) { return coord / (imgRef.naturalWidth / parentWidth); });
        }
        return coords.map(function (coord) { return coord * scale; });
    };
    var renderPrefilledAreas = function (mapObj) {
        if (mapObj === void 0) { mapObj = map; }
        mapObj.areas.map(function (area) {
            if (!area.preFillColor)
                return false;
            draw_1.default(area.shape, scaleCoords(area.coords), area.preFillColor, area.lineWidth || lineWidthProp, area.strokeColor || strokeColorProp, true, ctx);
            return true;
        });
    };
    var computeCenter = function (area) {
        if (!area)
            return [0, 0];
        var scaledCoords = scaleCoords(area.coords);
        switch (area.shape) {
            case 'circle':
                return [scaledCoords[0], scaledCoords[1]];
            case 'poly':
            case 'rect':
            default: {
                var n_1 = scaledCoords.length / 2;
                var _a = scaledCoords.reduce(function (_a, val, idx) {
                    var y = _a.y, x = _a.x;
                    return (!(idx % 2) ? { y: y, x: x + val / n_1 } : { y: y + val / n_1, x: x });
                }, { y: 0, x: 0 }), scaleY = _a.y, scaleX = _a.x;
                return [scaleX, scaleY];
            }
        }
    };
    var updateCanvas = function () {
        ctx.current.clearRect(0, 0, canvas.current.width, canvas.current.height);
        renderPrefilledAreas(mapProp);
    };
    var renderAreas = function () {
        return map.areas.map(function (area, index) {
            var scaledCoords = scaleCoords(area.coords);
            var center = computeCenter(area);
            var extendedArea = __assign(__assign({}, area), { scaledCoords: scaledCoords, center: center });
            if (area.disabled)
                return null;
            return (react_1.default.createElement("area", { key: area[areaKeyName] || index.toString(), shape: area.shape, coords: scaledCoords.join(','), onMouseEnter: function (event) { return hoverOn(extendedArea, index, event); }, onMouseLeave: function (event) { return hoverOff(extendedArea, index, event); }, onMouseMove: function (event) { return events_1.mouseMove(extendedArea, index, event, props); }, onMouseDown: function (event) { return events_1.mouseDown(extendedArea, index, event, props); }, onMouseUp: function (event) { return events_1.mouseUp(extendedArea, index, event, props); }, onTouchStart: function (event) { return events_1.touchStart(extendedArea, index, event, props); }, onTouchEnd: function (event) { return events_1.touchEnd(extendedArea, index, event, props); }, onClick: function (event) { return click(extendedArea, index, event); }, href: area.href, alt: "map" }));
        });
    };
    return (react_1.default.createElement("div", { id: "img-mapper", style: styles_1.default(props).container, ref: container },
        react_1.default.createElement("img", { role: "presentation", className: "img-mapper-img", style: styles_1.default(props).img, src: srcProp, useMap: "#" + map.name, alt: "map", ref: img, onLoad: function () { return initCanvas(true); }, onClick: function (event) { return events_1.imageClick(event, props); }, onMouseMove: function (event) { return events_1.imageMouseMove(event, props); } }),
        react_1.default.createElement("canvas", { className: "img-mapper-canvas", ref: canvas, style: styles_1.default().canvas }),
        react_1.default.createElement("map", { className: "img-mapper-map", name: map.name, style: styles_1.default().map }, isRendered && !disabled && renderAreas())));
};
ImageMapper.defaultProps = types_1.ImageMapperDefaultProps;
exports.default = react_1.default.memo(ImageMapper, function (prevProps, nextProps) {
    var watchedProps = __spreadArray(__spreadArray([], types_1.rerenderPropsList), nextProps.rerenderProps);
    var propChanged = watchedProps.some(function (prop) { return prevProps[prop] !== nextProps[prop]; });
    return react_fast_compare_1.default(prevProps.map, nextProps.map) && !propChanged;
});
